﻿Imports System
Imports System.Windows
Imports System.Windows.Controls

Namespace PolymorphismExample2

    Class PolymorphismExample2
        Inherits Application

        ' WPF apps should execute on a STA thread
        <STAThread>
        Shared Sub Main(args As String())
            Dim app As PolymorphismExample2 = New PolymorphismExample2()
            app.Run()
        End Sub

        Protected Overrides Sub OnStartup(e As StartupEventArgs)

            MyBase.OnStartup(e)
            Dim window As EventWindow = New EventWindow()
            window.Title = "Polymorphism Example"
            window.Height = 228
            window.Width = 300

            window.WindowStartupLocation =
                WindowStartupLocation.CenterScreen
            window.Show()
        End Sub
    End Class

    Class EventWindow
        Inherits Window

        Dim calendar As Calendar

        Public Sub New()

            Dim mainPanel As StackPanel = New StackPanel()
            calendar = New Calendar()
            Dim button1 As Button = New Button()
            button1.Content = "Highlight"
            Dim button2 As Button = New Button()
            button2.Content = "No Highlight"
            Dim button3 As Button = New Button()
            button3.Content = "More transparent"

            Dim buttonPanel As StackPanel = New StackPanel()
            buttonPanel.Orientation = Orientation.Horizontal
            buttonPanel.HorizontalAlignment =
                System.Windows.HorizontalAlignment.Center
            buttonPanel.Children.Add(button1)
            buttonPanel.Children.Add(button2)
            buttonPanel.Children.Add(button3)

            mainPanel.Children.Add(calendar)
            mainPanel.Children.Add(buttonPanel)

            AddHandler button1.Click, AddressOf OnClick1
            AddHandler button2.Click, AddressOf OnClick2
            AddHandler button3.Click, AddressOf OnClick3

            Me.Content = mainPanel
        End Sub

        Sub OnClick1(sender As Object, e As RoutedEventArgs)
            calendar.IsTodayHighlighted = True
        End Sub

        Sub OnClick2(sender As Object, e As RoutedEventArgs)
            calendar.IsTodayHighlighted = False
        End Sub

        Sub OnClick3(sender As Object, e As RoutedEventArgs)
            Dim panel As Panel = CType(Me.Content, Panel)
            For Each child As UIElement In panel.Children
                MakeMoreTransparent(child)
            Next
        End Sub

        Sub MakeMoreTransparent(uiElement As UIElement)
            Dim opacity As Single = uiElement.Opacity
            If (Opacity > 0.2) Then
                UIElement.Opacity = Opacity - 0.1
            End If
        End Sub

    End Class
End Namespace
